(function () {
    try {
        const hashParamStr = window.location.hash;
        const paramsIdx = hashParamStr.indexOf('?');
        let params;
        if (paramsIdx > 0) {
            const hashUrl = new URL('https://0/' + hashParamStr.substring(1));
            params = hashUrl.searchParams;
        } else {
            params = new URLSearchParams();
        }
        const isScreenSaver = params.get('mode') === 'screensaver';
        const isPresentation = params.get('mode') === 'presentation';
        const silentBootParam = params.get('silentBoot');
        let overrideStyle = '';
        if ((isScreenSaver || isPresentation
                || silentBootParam || localStorage.getItem('player.pref.silentBoot'))
            && silentBootParam !== 'false') {
            window.nvIsSilentBoot = true;
            // hide loading indicator
            overrideStyle += "#initialLdSplash { display: none !important; } ";
        }
        if ((isScreenSaver || isPresentation || params.get('hideCursor')) && params.get('hideCursor') !== false) {
            overrideStyle += "html,body { " +
                "cursor: none  !important; " +
                "} ";
        }
        if ((isScreenSaver || params.get('closeOnInteraction')) && params.get('closeOnInteraction') !== 'false') {
            window.nvCloseOnInteraction = function (evt) {
                evt.stopImmediatePropagation();
                evt.stopPropagation();
                evt.returnValue = false;
                window.close();
            };
            const interactionEvents = [
                'mouseup', 'mousemove', 'mousedown', 'mouseenter', 'mouseleave', 'keyup', 'keydown', 'keypress'
            ];
            for (const eventName of interactionEvents) {
                window.addEventListener(eventName, window.nvCloseOnInteraction, true);
            }
        }
        let screenColor = params.get('screenColor') || localStorage.getItem('player.pref.screenColor');
        if (screenColor) {
            overrideStyle += `html,body { background-color: ${screenColor} !important; } `;
        }
        if (overrideStyle) {
            const node = document.createElement("style");
            node.setAttribute("rel", "stylesheet");
            node.innerHTML = overrideStyle;
            document.head.appendChild(node);
        }
    } catch (e) {
        window.nvJsInitError = 'error initializing parameters ' + e;
        console.error('error initializing parameters', e);
    }
})();
